//DecodePicScale.c
#include "DecodePicFlash.h"
#include "EncodePicFlash.h"

void DecompressPicFlash(INT16 *matrix, INT8 qmin,char *filenamein) {
  InitReadBit(filenamein);
  UINT16 DimPic=matrix[0];
  printf("DimPic=%i\n",DimPic);
  //use 16 bit signed wavelet coefficients (INT16)
  int j;for (j=0;j<DimPic*DimPic;j++) matrix[j+1]=0;//init matrix

  INT8 qmax=14;//constant for decoding the last level m(0)
  
  INT16 LineBuffer[DimPic];
  INT8 MaxLevel=(INT8) Log2(DimPic);
  UINT8 DimMqlBuffer=0; //allocate Mql buffer:
  INT8 i;for (i=1;i<=MaxLevel-2;i++) DimMqlBuffer+=DimPic/Pow(2,i+1);
  INT8 MqlBuffer[DimMqlBuffer];
  
  char subband[3]="HH\n";
  INT8 qG123[4];
  //1)
  DecodeLastLevels(matrix,LineBuffer,qG123,qmin,qmax);
  printf("decoded last levels\n");
  //2) decode the 3 subbands
  for (i=3;i>=1;i--){
    if (i==1)      {subband[0]='H';subband[1]='L';}//'HL'
    else if (i==2) {subband[0]='L';subband[1]='H';}//'LH'
    else if (i==3) {}                              //'HH'
    //2a)
    PutMql(MqlBuffer,DimPic,MaxLevel-2,0,qG123[i]);
    //2bc)
    Decode2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,0,qmin);
    Decode2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,2,qmin);
  }
  //SendString("\nDecompression done!\n>>");
}

void Decode2Lines(INT16 *matrix,INT8 *MqlBuffer,INT16 *LineBuffer,\
		  char *subband,INT8 level,UINT8 k,INT8 qmin) {
  //printf("Decode2lines-band:%s,level:%i,k:%i \n",subband,level,k); 
  UINT16 DimPic=matrix[0];
  UINT8 DimMql=DimPic/Pow(2,level+1);
  INT8 TwoSets;//0:+2:DimMql-1
  INT8 m[4];//m1-m4 in m[0]-m[3]

  //1)init coefficients in line buffer with 0
  UINT16 i;
  for(i=0;i<DimPic;i++)LineBuffer[i]=0;
  //2)do forall sets of 8 adjacent coeff
  for (TwoSets=1;TwoSets<DimMql;TwoSets+=2){
    INT8 i;
    //2a) 
    if (k%4==0) {
      //i) get qG from buffer
      INT8 qG;
      qG=GetMql(MqlBuffer,DimPic,level,TwoSets-1);
      //ii)decode m1,m2,m3,m4 using qG
      INT8 i;
      //printf("qG:%i,qmin:%i ",qG,qmin);//exit(0);
      if (qG>=qmin) for (i=0;i<=3;i++) m[i]=DecodeLevel(qmin,qG);
      else          for (i=0;i<=3;i++) m[i]=-1;
      //iii) put m2,m3 to buffer
      PutMql(MqlBuffer,DimPic,level,TwoSets-1,m[2]);
      PutMql(MqlBuffer,DimPic,level,TwoSets,  m[3]);
    }
    else {//k%4==2
      m[0]=GetMql(MqlBuffer,DimPic,level,TwoSets-1);
      m[1]=GetMql(MqlBuffer,DimPic,level,TwoSets);
    }
    //2b) 
    for (i=0;i<=1;i++) {
      INT8 set=TwoSets+i-1;
      //2b i) decode 4 coeff
      INT8 j;if (m[i]>=qmin) for (j=0;j<=3;j++)
	LineBuffer[InvGiveSet(DimMql,set)]=DecodePixelFlash(qmin,m[i]);
      //2b ii)
      if (level>1){
	//A)B)
	INT8 qGi=-1;if (m[i]>=qmin) qGi=DecodeLevel(qmin,m[i]);
	PutMql(MqlBuffer,DimPic,level-1,set*2,qGi);}  
    }
  }// TwoSets
  //3) write 2 lines to matrix
  Write2Lines(matrix,LineBuffer,subband,level,k);
  //4) decode (level-1) lines at (2k) and (2k+2)
  if (level>1){
    //a)b)
    Decode2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k,qmin);
    Decode2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k+2,qmin);
  }
}

INT8 DecodeLastLevels(INT16 *matrix,INT16 *LineBuffer,INT8 *qG,\
		      INT8 qmin,INT8 qmax){
  INT8 i;
  INT8 m_i[4];
  //1)decode m(0) using qmax
  //printf("start ");
  m_i[0]=DecodeLevel(qmin,qmax);
  //printf("qmin:%i qmax:%i decoded m0:%i ",qmin,qmax,m_i[0]);
  //2)
  UINT8 pos[4]={0,1,4,5};
  //3)decode coeff at pos(i) using m(0)
  for(i=3;i>=0;i--)LineBuffer[pos[i]]=DecodePixelFlash(qmin,m_i[0]);
  //4)decode qG(0) using m(0)
  qG[0]=DecodeLevel(qmin,m_i[0]);
  //5)
  for (i=3;i>=1;i--){
    //5a)
    m_i[i]=DecodeLevel(qmin,qG[0]);
    //5b)
    UINT8 j;
    if (m_i[i]>=qmin) for (j=1;j<=4;j++)
      LineBuffer[InvGiveChilds(pos[i],4)]=DecodePixelFlash(qmin,m_i[i]);
    //5c)
    qG[i]=DecodeLevel(qmin,m_i[i]);
  }
  //6)write LineBuffer (a 4x4 matrix) to "matrix"
  i=0;
  UINT16 m=0;
  UINT16 DimPic=matrix[0];
  while (i<=15) {
    matrix[m+1]=LineBuffer[i];
    i++;m++;
    if (m%4==0) m+=DimPic-4;
  }
  //7)qG(i=1,2,3) is returned
}


void Write2Lines(INT16 *matrix,INT16 *LineBuffer,\
		 char* subband,INT8 level,UINT8 k){
  //almost the same fct as Read2Lines in EncodePicFlash()
  //k is the line index; write line k and line (k+1)
  //k starts at 0 (first line in the subband)
  UINT16 DimPic=matrix[0];
  
  UINT8 DimSub=DimPic/Pow(2,level);
  UINT16 m;
  if (subband[0]=='L')  m=DimPic    *DimSub;//LH
  else if (subband[1]=='L') m=DimSub;       //HL
  else m=(DimPic+1)*DimSub;                 //HH
  m+=k*DimPic;//move to the correct line
  UINT16 i;
  for (i=0;i<2*DimSub;i++){
    //this is the only line different to Read2Lines()
    matrix[m+1]=LineBuffer[i];//  <-
    m++;
    if (i==DimSub-1) m=m+DimPic-DimSub;//perform line break
  }
}


UINT16 InvGiveSet(UINT8 DimMql,UINT8 set) {
  //returns the 4 coefficient indices of a set;index starts from 0
  //  1 2
  //  3 4
  static INT8 m=1;
  UINT16 index;
  if (m<=2) index=set*2+m-1;
  else if (m>2) index=set*2+m+DimMql*2-3;
  m++;if (m==5) m=1;
  return index;
}


INT16 DecodePixelFlash(INT8 qmin,INT8 mqd){
  //static int counter=0;counter++;if (counter>=50) return 0;

  //printf("called Decode Pixel");
  INT16 coefficient=0;
  INT8 exp;
  for (exp=mqd;exp>=qmin;exp--) if (ReadBit()) {
    INT16 mask=1<<exp;//INT16 mask=Pow(2,exp);
    coefficient=coefficient|mask;  
  }
  //if (coefficient>=Pow(2,qmin)) 
  if (coefficient>=1<<qmin) {//if coeff > 0
    //March 1,2008: important correction that improves PSNR by 1 !!!
    //if bits are cut the error of the decoded coeff is moved to the midth
    if (qmin>=1) coefficient=coefficient|(1<<(qmin-1));
    if (!ReadBit()) coefficient*=-1;//sign bit
  }
  //printf("DecPixFlash:%i ",coefficient);
  return coefficient;
}



INT8 DecodeLevel(INT8 qmin,INT8 UpperBound){
  //printf("called Decode Level");
  while (UpperBound-qmin+1>0) 
    if (!ReadBit()) UpperBound--;
    else break;
  //printf("lev:%i ",UpperBound);
  return UpperBound;
}
UINT16 InvGiveChilds(UINT16 root,UINT16 MaxCols){
  static INT8 child=1;
  UINT16 i,j;
  UINT16 m;
  GiveIJ(&i,&j,root,MaxCols); 
  if      (child==1) m=GiveM(2*i+1,2*j+1,MaxCols);
  else if (child==2) m=GiveM(2*i+1,2*j,  MaxCols);     
  else if (child==3) m=GiveM(2*i,  2*j+1,MaxCols);  
  else if (child==4) m=GiveM(2*i,  2*j,  MaxCols);   
  child++;
  if (child==5) child=1;
  return m;
}
