//DecodePicScale.c
#include"DecodePicScale.h"


void RefinePicFlash(char *filename,char* filenBinRef,INT16 *matrix,INT8 qminPrv,INT8 qmin) {
  // filename= name of input binary file
  // matrix = input matrix to be updated here
  //use 16 bit signed wavelet coefficients (INT16)
  // qminPrv is needed only to correct for the previous rounding method
  InitReadBit(filename);
  InitReadBit2(filenBinRef);

  UINT16 DimPic=matrix[0];printf("DimPic=%i\n",DimPic);
  GetQminPrv(qminPrv);//set the qminPrv value
  INT8 qmax=14;//constant for decoding the last level m(0)
  
  INT16 LineBuffer[DimPic];
  INT8 MaxLevel=(INT8) Log2(DimPic);
  UINT8 DimMqlBuffer=0; //allocate Mql buffer:
  INT8 i;for (i=1;i<=MaxLevel-2;i++) DimMqlBuffer+=DimPic/Pow(2,i+1);
  INT8 MqlBuffer[DimMqlBuffer];
  
  char subband[3]="HH\n";
  INT8 qG123[4];
  //1)
  DecodeLastLevels(matrix,LineBuffer,qG123,qminPrv,qmax);
  RefineLastLevels(matrix,LineBuffer,qG123,qmin,qminPrv-1);
 
  printf("refined last levels\n");
  
  //exit(0);
  //2) refine the 3 subbands:
  for (i=3;i>=1;i--){
    if (i==1)      {subband[0]='H';subband[1]='L';}//'HL'
    else if (i==2) {subband[0]='L';subband[1]='H';}//'LH'
    else if (i==3) {}                              //'HH'
    //2a)
    PutMql(MqlBuffer,DimPic,MaxLevel-2,0,qG123[i]);
    //2bc)
    Refine2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,0,qminPrv,qmin);
    Refine2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,2,qminPrv,qmin);
  }
  //SendString("\nPicture refined!\n>>");
}

void Refine2Lines(INT16 *matrix,INT8 *MqlBuffer,INT16 *LineBuffer,\
		  char *subband,INT8 level,UINT8 k,INT8 qminPrv,INT8 qmin) {
  //printf("Decode2lines-band:%s,level:%i,k:%i \n",subband,level,k); 
  UINT16 DimPic=matrix[0];
  UINT8 DimMql=DimPic/Pow(2,level+1);
  INT8 TwoSets;//0:+2:DimMql-1
  INT8 set;
  INT8 m[4];//m1-m4 in m[0]-m[3]

  //1) Init coeff in line buffer:
  UINT16 i;
  for(i=0;i<DimPic;i++)LineBuffer[i]=0;
  
  //2)do forall sets of 8 adjacent coeff
  for (TwoSets=1;TwoSets<DimMql;TwoSets+=2){
    INT8 i;
    //2a) 
    if (k%4==0) {
      //i) get qG from buffer
      INT8 qG;
      qG=GetMql(MqlBuffer,DimPic,level,TwoSets-1);
      //printf("qG=%i ",qG);
      //ii)decode m1,m2,m3,m4 using qG
      INT8 i;
      //printf("qG:%i,qmin:%i ",qG,qmin);//exit(0);
      if (qG>=qmin) for (i=0;i<=3;i++) m[i]=DecodeLevelScale(qmin,qG);
      else          for (i=0;i<=3;i++) m[i]=-1;
      //iii) put m2,m3 to buffer
      PutMql(MqlBuffer,DimPic,level,TwoSets-1,m[2]);
      PutMql(MqlBuffer,DimPic,level,TwoSets,  m[3]);
    }
    else {//k%4==2
      m[0]=GetMql(MqlBuffer,DimPic,level,TwoSets-1);
      m[1]=GetMql(MqlBuffer,DimPic,level,TwoSets);
    }
    //2b) 
    for (i=0;i<=1;i++) {
      set=TwoSets+i-1;
      //2b i) decode 4 coeff
      INT8 j;if (m[i]>=qmin) for (j=0;j<=3;j++) {
	  UINT16 LnBfInd=InvGiveSet(DimMql,set);
	  INT16 pixel=DecodePixelScale(qmin,m[i]);
	  if (pixel!=0) LineBuffer[LnBfInd]=pixel;
	}
      //2b ii)
      if (level>1){
	//A)B)
	INT8 qGi=-1;if (m[i]>=qmin) qGi=DecodeLevelScale(qmin,m[i]);
	PutMql(MqlBuffer,DimPic,level-1,set*2,qGi);}  
    }
  }// end TwoSets
  //3) write 2 lines to matrix
  Write2Lines(matrix,LineBuffer,subband,level,k);
  //4) decode (level-1) lines at (2k) and (2k+2)
  if (level>1){
    //a)b)
    //exit(0);
    Refine2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k,  qminPrv,qmin);
    Refine2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k+2,qminPrv,qmin);
  }
}


INT8 RefineLastLevels(INT16 *matrix,INT16 *LineBuffer,INT8 *qG,\
		      INT8 qmin,INT8 qmax){
  //1) Read last 2 levels from matrix to line buffer
  //2) Refine coefficients
  //3) Refine qG[i] of prev. levels
  //4) write LineBuffer to matrix
  INT8 qminPrv=GetQminPrv(-1);//get the qminPrv value
  //1)Read last two levels(16 coeff)from matrix to line buffer
  UINT16 DimPic=matrix[0];
  INT8 i;
  UINT16 m=0;
  UINT8 MaxLevelPrv=0;
  for (i=0;i<=15;i++) {
    LineBuffer[i]=matrix[m+1];m++;
    if (m%4==0) m+=DimPic-4;
  }
  //2)Refine coefficients
  for (i=15;i>=0;i--){
    if (Givelevel(LineBuffer,i)>=qminPrv) LineBuffer[i]=UpdatePixelScale(qmin,LineBuffer[i]);
    else LineBuffer[i]=DecodePixelScale(qmin,qminPrv-1);
  }
  //3)Refine qG[i] of next levels
  for (i=3;i>=1;i--) {if (qG[i]<qminPrv) qG[i]=DecodeLevelScale(qmin,qminPrv-1);}
  //4)write LineBuffer (a 4x4 matrix) to "matrix"
  m=0;
  for (i=0;i<=15;i++) {matrix[m+1]=LineBuffer[i];
    m++;if (m%4==0) m+=DimPic-4;}
}

INT16 DecodePixelScale(INT8 qmin,INT8 qmax){
  INT8 qminPrv=GetQminPrv(-1);
  INT16 pixel=0;
  //qmax>=qminPrv? Was pixel already encoded?
  //1a) decode pixel using the old stream
  //1a)i. if pixel >=qminPrv update pixel using new stream wo sign
  //1a)ii.else         decode pixel from new stream w sign
  //else pixel was not encoded: decode pixel using new binary stream
  if (qmax>=qminPrv) {//set of coefficients was already encoded
    pixel=DecodePixelFlash(qminPrv,qmax);
    if (GiveLevel(pixel)>=qminPrv) {//update pixel:
      pixel=UpdatePixelScale(qmin,pixel);
      return pixel;
    } 
    else qmax=qminPrv-1;//pix==0:decode pixel from new stream w sign
  }
  //decode pixel from prog.binary stream w sign using qmin and qmax:
  INT8 exp;
  for (exp=qmax;exp>=qmin;exp--) if (ReadBit2()) {
      INT16 mask=1<<exp;
      pixel=pixel|mask;  
    }
  //Rounding method:
  //if (pixel>=Pow(2,qmin)) 
  if (pixel>=1<<qmin) {//if coeff > 0
    if (qmin>=1) pixel=pixel|(1<<(qmin-1));
    if (!ReadBit2()) pixel*=-1;//sign bit
  }
  //printf("DecPixSc:%i ",pixel);
  return pixel; 
}

INT16 UpdatePixelScale(INT8 qmin,INT16 pixelPrv) {
  //decode a new pixel from the progressive stream und use it to update
  //the LSB bits of the previously decoded pixel "pixelPrv"
  INT8 qminPrv=GetQminPrv(-1);//needed as qmax for pixel update and delete prev rounding bit
  INT16 pixel=0;
  //decode lower bits of pixel from new binary stream wo sign 
  //using qmin and qminPrv-1:
  INT8 exp;
  for (exp=qminPrv-1;exp>=qmin;exp--) if (ReadBit2()) {
    INT16 mask=1<<exp;//INT16 mask=Pow(2,exp);
    pixel=pixel|mask;
  }
  //add the newly decoded bits to the pixel:
  //1) rounding method for decoded pixel
  if (qmin>=1) pixel=pixel|(1<<(qmin-1));
  //2) get sign bit from pixelPrv
  INT8 sign=1;
  if (pixelPrv<0) sign=-1;//get the sign from pixelPrv
  pixelPrv=abs(pixelPrv);//take off sign bit to deal with 2's complement
  //3) delete rounding bit in PixelPrv(regardless if there has been any or not):
  if (qminPrv>=1) pixelPrv &= ~(1<<(qminPrv-1));//clear the qminPrv-1 bit
  //4) Update pixelPrv with decoded coeff:
  pixelPrv= (pixelPrv|pixel)*sign;//update pixelPrv=pixelPrv+pixel  
  
  //printf("UpdPixSc:%i ",pixelPrv);
  return pixelPrv;
}

INT8 DecodeLevelScale(INT8 qmin,INT8 UpperBound){
  //1) is UpperBound>=qminPrv? check if level has already been encoded
  //   yes: decode level: is level>=qminPrv? has it been zero ?
  //         no: return
  //         yes:decode lev from progr.stream with UpperBound=qminPrv-1
  //   no:  decode level from progressive stream using the UpperBound

  INT8 qminPrv=GetQminPrv(-1);
  INT8 level;
  if (UpperBound>=qminPrv) {//1)level has already been encoded
    level=DecodeLevel(qminPrv,UpperBound);
    if (level>=qminPrv) { //printf("DecLevScUsual:%i",level);
      return level;//1a) decode level as usual
    }
    //else if level==0
    UpperBound=qminPrv-1;//1b): level was 0 and may be refined
  } 
  //2) / 1b) :else decode level from progressive binary using qmin and UpperBound:
  while (UpperBound-qmin+1>0) 
    if (!ReadBit2()) UpperBound--;//use progressive stream
    else break;
  //printf("DecLevSc:%i ",UpperBound);
  return UpperBound;
}

