//EncodePicFlash.c
#include"EncodePicFlash.h"

void CompressPicFlash(INT16 *matrix, INT8 qmin,char* fn){
  printf("Function CompressPicFlash() with qmin=%i\n>>",qmin);
  InitWriteBit(fn);//init a file stream with name fn 

  INT8 qmax=14;//will be used to encode the max quant.lev of the pic
  UINT16 DimPic=matrix[0];printf("dim: %i\n",DimPic);
  //allocate line-buffer with a dimension of DimPic
  INT16 LineBuffer[DimPic];
  INT8 MaxLevel=(INT8)Log2(DimPic);
  printf("MaxLevel=%i \n",MaxLevel);
  UINT8 DimMqlBuffer=0;
  INT8 i;for (i=1;i<=MaxLevel-2;i++) DimMqlBuffer+=DimPic/Pow(2,i+1);
  //allocate mql-buffer:
  INT8 MqlBuffer[DimMqlBuffer];
  //1) Code 3 subbands:
  char subband[3]="HL\n";
  INT8 qG123[4];//qG(0) is assigned in CodeLastLevels()
  for (i=1;i<=3;i++) {
    if (i==1)      {}                              //'HL'
    else if (i==2) {subband[0]='L';subband[1]='H';}//'LH'
    else if (i==3) {subband[0]='H';}               //'HH'
    Code2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,2,qmin);
    Code2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,0,qmin);
    qG123[i]=GetMql(MqlBuffer,DimPic,MaxLevel-2,0);//m=0->qG is in left field
   
  }
  //2)code the last 2 levels 
  CodeLastLevels(matrix,LineBuffer,qG123,qmin,qmax);
  for (i=1;i<=3;i++) printf("qG=%i ",qG123[i]);
  WriteBit(3); // "3" signals to close the file stream
}

void Code2Lines(INT16 *matrix,INT8 *MqlBuffer,INT16* LineBuffer,char *subband,INT8 level,UINT8 k,INT8 qmin){
  //code lines k and (k+1)

  UINT16 DimPic=matrix[0];
  //1) Encode (level-1) lines at (2k+2) and (2k):
  if (level>1) {
    Code2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k+2,qmin);
    Code2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k,qmin);
  }
  //printf("Code2lines-band:%s,level:%i,k:%i \n",subband,level,k);
  //2) Read lines k and k+1 into buffer:
  Read2Lines(matrix,LineBuffer,subband,level,k);
  //3) Do forall sets of 8 adjacent coefficients
  INT8 m[4];
  UINT8 DimMql=DimPic/Pow(2,level+1);
  INT8 TwoSets;//DimMql-1 : -2: 1
  for (TwoSets=DimMql-1;TwoSets>0;TwoSets=TwoSets-2){
    //3a)
    INT8 qG_i=-1;//q_G(i)(level-1)
    INT8 i;
    // set=TwoSets-i
    for (i=1;i>=0;i--){
      INT8 set=TwoSets+i-1;
      //3a i) Get qG_i and compute m_i:
      if (level>1)
	qG_i= GetMql(MqlBuffer,DimPic,level-1,set*2);//start with right set (i=0)
      //3 a ii) 
      m[i]=Max(  qG_i,GiveMqlSet(LineBuffer,DimMql,set)   );
      //3a iii) 
      if (m[i]>=qmin){
	//A) Encode qG_i using m(i):
	if (level>1) CodeLevel(qG_i,Max(qG_i,qmin),m[i]);
	//B) Encode set i of 4 coeff using m(i):
	INT8 j;
	for (j=1;j<=4;j++){
	  INT16 pixel=LineBuffer[GiveSet(DimMql,set)];
	  CodePixelFlash(pixel,qmin,m[i]);
	} //j=1:4 
      }
    }
    //3b)
    //if k/2==odd->first two lines->write m0 and m1 to buffer 
    if (k%4==2) for (i=1;i>=0;i--) PutMql(MqlBuffer,DimPic,level,TwoSets+i-1,m[i]);
    else {// k/2==even->second two lines
      //3b i) Get m2,m3 of prev.two lines from buffer
      for (i=1;i>=0;i--) m[i+2]=GetMql(MqlBuffer,DimPic,level,TwoSets+i-1);
      //3b ii) Compute qG=Max(m1234)
      INT8 qG=-1;for (i=0;i<=3;i++) qG=Max(qG,m[i]);
      //3b iii) Encode m1234 using qG:
      if (qG>=qmin) for (i=3;i>=0;i--) CodeLevel(m[i],Max(m[i],qmin),qG);
      //3b iv) Write qG to buffer on position of m2(left of the two positions)
      PutMql(MqlBuffer,DimPic,level,TwoSets-1,qG);
    } 
  }//for TwoSets
}


void CodeLastLevels(INT16 *matrix,INT16 *LineBuffer,INT8 *qG,INT8 qmin,INT8 qmax){
  printf("Coding last 2 levels\n");
  UINT16 DimPic=matrix[0];
  //1)Read 4x4 matrix of last two levels into input line buffer
  INT8 i=0;
  UINT16 m=0;
  while (i<=15) {
    LineBuffer[i]=matrix[m+1];
    i++;m++;
    if (m%4==0) m+=DimPic-4;
  }
  //2)Denote positions of H as pos(0,1,2,3) and of H_excluding_LL as pos(1,2,3)
  UINT8 pos[4]={0,1,4,5};
  //3)Compute m(i)
  INT8 m_i[4];
  for (i=1;i<=3;i++) {
    m_i[i]=qG[i];
    //compute max(q_j)(1,2,3) at childs of pos(1,2,3):
    UINT8 j;
    for (j=1;j<=4;j++) {
      m=GiveChilds(pos[i],4);//root, MaxCols
      m_i[i]=Max(m_i[i],Givelevel(LineBuffer,m));
    }
  }
  //4)Compute qG0
  qG[0]=-1;
  for (i=1;i<=3;i++) qG[0]=Max(qG[0],m_i[i]);
  //5) 
  for (i=1;i<=3;i++){
    //5 a)Encode qG(i=1,2,3) using m(i=1,2,3)
    CodeLevel(qG[i],  Max(qG[i],qmin)  ,m_i[i]);
    //5 b)Encode coeff of the MaxLevel-1 subbands
    UINT8 j;
    if (m_i[i]>=qmin) for (j=1;j<=4;j++) {
      m=GiveChilds(pos[i],4);//root, MaxCols
      CodePixelFlash(LineBuffer[m],qmin,m_i[i]);
    }
    //5 c)Encode m_i(i) using qG0
    CodeLevel(m_i[i],Max(m_i[i],qmin),qG[0]);
  }
  //6)Compute m0
  m_i[0]=qG[0];
  for (i=0;i<=3;i++) m_i[0]=Max(  m_i[0],Givelevel(LineBuffer,pos[i])   );
  //7)Encode qG0 using m0
  CodeLevel(qG[0],Max(qG[0],qmin),m_i[0]);
  //8)Encode coeff of H
  for (i=0;i<=3;i++) CodePixelFlash(LineBuffer[pos[i]],qmin,m_i[0]);
  //9)Encode m0 using qmax
  //printf("Encode m0:%i ",m_i[0]);
  CodeLevel(m_i[0],Max(m_i[0],qmin),qmax);
}


void Read2Lines(INT16 *matrix,INT16 *buffer,char *subband,INT8 level,UINT8 k){
  // k is the line index;read line k and (k+1) 
  // line 0 is the first line, line 1 is the second one
  UINT16 DimPic=matrix[0];
   
  UINT8 DimSub=DimPic/Pow(2,level);
  UINT16 m;
  if (subband[0]=='L')  m=DimPic    *DimSub;//LH
  else if (subband[1]=='L') m=DimSub;       //HL
  else m=(DimPic+1)*DimSub;                 //HH
  //if (subband=="HL")      m=DimSub;
  //else if (subband=="LH") m=DimPic    *DimSub;
  //else if (subband=="HH") m=(DimPic+1)*DimSub;
  m+=k*DimPic;//move to the correct line
  UINT16 i;
  for (i=0;i<2*DimSub;i++){
    buffer[i]=matrix[m+1];
    m++;
    if (i==DimSub-1) m=m+DimPic-DimSub;//perform line break
  }
}



UINT16 GiveSet(UINT8 DimMql,UINT8 set){
  //returns the 4 coefficients of a set; set index starts from 0
  // 4 3
  // 2 1
  static INT8 m=1;
  UINT16 index;
  if      (m<=2) index=set*2+DimMql*2+2-m;
  else if (m>2)  index=set*2+4-m;
  m++;if (m==5) m=1;  
  return index;
}

INT8 GiveMqlSet(INT16 *LineBuffer,UINT8 DimMql,UINT8 set){
  //returns the maximum quantization level of the Set "set"
  INT8 mql=-1;
  INT8 QuLevel;
  INT8 i;
  for (i=1;i<=4;i++) {
    QuLevel=Givelevel(LineBuffer,GiveSet(DimMql,set));
    mql=Max(mql,QuLevel);
  }
  return mql;
}

/*INT8 GiveMqlSetQminPrv(INT16 *LineBuffer,UINT8 DimMql,UINT8 set,INT8 qminPrv){
  //returns the maximum quantization level of the Set "set"
  INT8 mql=-1;
  INT8 QuLevel;
  INT8 i;
  for (i=1;i<=4;i++) {
    QuLevel=GivelevelQminPrv(LineBuffer,GiveSet(DimMql,set),qminPrv);
    mql=Max(mql,QuLevel);
  }
  return mql;
}
*/

INT8 Givelevel(INT16 *LineBuffer,UINT16 m){
  if (abs(LineBuffer[m])>=1) return (INT8) Log2(  abs(LineBuffer[m])  );
  else return -1;
}
/*INT8 GivelevelQminPrv(INT16 *LineBuffer,UINT16 m,INT8 qminPrv){
  INT8 exp;
  for (exp=qminPrv-1;exp>=0;exp--) {//traverse from left to right
    // 1=0..0001    
    // coefficients are in the 2's complement and MSB is sign bit
    UINT16 mask=1<<exp;// 1<<0=0..001, 1<<1=0..010
    //extract the bit:
    UINT16 bit=  mask & abs(LineBuffer[m]);// abs() due to 2's complement
    if (bit>0) return exp;
  }
  return -1;// coefficient = 0
}
*/

void CodePixelFlash(INT16 pixel,INT8 qmin,INT8 qmax){
  //static UINT16 count=0;count++;//
  //printf("pix:%i ",pixel);
  if (abs(pixel)>=1<<qmin) WriteBit(pixel>=0);//sign bit
  INT8 exp;
  for (exp=qmin;exp<=qmax;exp++) { 
    //UINT16 mask=pow(2,exp);
    UINT16 mask=1<<exp;
    UINT16 bit=abs(pixel) & mask;//extract the bit
    WriteBit(bit>0);
  } 
}


void CodeLevel(INT8 level,INT8 LowerBound,INT8 UpperBound){
  //static UINT16 count=0;count++;//
  //printf("lev val=%i ",level);
  //printf("CodeLev:%i \n",level);
  INT8 exp;
  for (exp=LowerBound;exp<=UpperBound;exp++)
      WriteBit(exp==level);
}

INT8 Max(INT8 level1,INT8 level2){
  if (level1>level2) return level1;
  else return level2;
}

UINT16 GiveChilds(UINT16 root,UINT16 MaxCols){
  static INT8 child=1;
  static UINT16 i,j;
  UINT16 m;// calculated child position
  if (child==1) { GiveIJ(&i,&j,root,MaxCols);
                     m=GiveM(2*i,2*j,    MaxCols);}
  else if (child==2) m=GiveM(2*i,2*j+1,  MaxCols);     
  else if (child==3) m=GiveM(2*i+1,2*j,  MaxCols);  
  else if (child==4) m=GiveM(2*i+1,2*j+1,MaxCols);   
  child++;
  if (child==5) child=1;
  return m;
}


