//EncodePicScale.c

#include"EncodePicScale.h"


void RecodePicFlash(INT16 *matrix,INT8 qminPrv,INT8 qmin,char* fn) {
  printf("RecodePicFlash() with qminPrv=%i and qmin=%i\n>>",qminPrv,qmin);
  InitWriteBit(fn);//init a file stream with name fn 
  GetQminPrv(qminPrv);//set the qminPrv value

  INT8 qmax=qminPrv-1;//to encode the max quant.lev of the pic in RecodeLastLev()
  UINT16 DimPic=matrix[0];printf("dim: %i\n",DimPic);
  //allocate line-buffer with a dimension of DimPic
  INT16 LineBuffer[DimPic];
  INT8 MaxLevel=(INT8)Log2(DimPic);
  printf("MaxLevel=%i \n",MaxLevel);
  UINT8 DimMqlBuffer=0;
  INT8 i;for (i=1;i<=MaxLevel-2;i++) DimMqlBuffer+=DimPic/Pow(2,i+1);
  //allocate mql-buffer:
  INT8 MqlBuffer[DimMqlBuffer];
  //1) Code 3 subbands:
  char subband[3]="HL\n";
  INT8 qG123[4];//qG(0) is assigned in CodeLastLevels()
  for (i=1;i<=3;i++) {
    if (i==1)      {}                              //'HL'
    else if (i==2) {subband[0]='L';subband[1]='H';}//'LH'
    else if (i==3) {subband[0]='H';}               //'HH'
    Recode2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,2,qminPrv,qmin);
    Recode2Lines(matrix,MqlBuffer,LineBuffer,subband,MaxLevel-2,0,qminPrv,qmin);
    qG123[i]=GetMql(MqlBuffer,DimPic,MaxLevel-2,0);//m=0->qG is in left field
  }
  //2)code the last 2 levels 
  RecodeLastLevels(matrix,LineBuffer,qG123,qmin,qmax);
  WriteBit(3); // "3" signals to close the file stream
}



void Recode2Lines(INT16 *matrix,INT8 *MqlBuffer,INT16* LineBuffer,char *subband,INT8 level,UINT8 k,INT8 qminPrv,INT8 qmin){
  //code lines k and (k+1)

  UINT16 DimPic=matrix[0];
  UINT8 DimMql=DimPic/Pow(2,level+1);
  INT8 set;
  //1) Encode (level-1) lines at (2k+2) and (2k):
  if (level>1) {
    Recode2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k+2,qminPrv,qmin);
    Recode2Lines(matrix,MqlBuffer,LineBuffer,subband,level-1,2*k,qminPrv,qmin);
  }
  //printf("Code2lines-band:%s,level:%i,k:%i \n",subband,level,k);
  //2) Read lines k and k+1 into buffer:
  Read2Lines(matrix,LineBuffer,subband,level,k);
  //3) Do forall sets of 8 adjacent coefficients
  INT8 m[4];
 
  INT8 TwoSets;//DimMql-1 : -2: 1
  for (TwoSets=DimMql-1;TwoSets>0;TwoSets=TwoSets-2){
    //3a)
    INT8 qG_i=-1;//q_G(i)(level-1)
    INT8 i;
    // set=TwoSets-i
    for (i=1;i>=0;i--){
      set=TwoSets+i-1;
      //3a i) Get qG_i and compute m_i:
      if (level>1)
	qG_i= GetMql(MqlBuffer,DimPic,level-1,set*2);//start with right set (i=0)
      //3 a ii) 
      m[i]=Max(  qG_i,GiveMqlSet(LineBuffer,DimMql,set)   );
      //3a iii) 
      if (m[i]>=qmin){
	//A) Encode qG_i using m(i):
	if (level>1) EncodeLevelScale(qG_i,Max(qG_i,qmin),m[i]);
	//B) Encode set i of 4 coeff using m(i):
	INT8 j;
	for (j=1;j<=4;j++){
	  INT16 pixel=LineBuffer[GiveSet(DimMql,set)];
	  EncodePixelScale(pixel,qmin,m[i]);
	} //j=1:4 
      }
    }
    //3b)
    //if k/2==odd->first two lines->write m0 and m1 to buffer 
    if (k%4==2) for (i=1;i>=0;i--) PutMql(MqlBuffer,DimPic,level,TwoSets+i-1,m[i]);
    else {// k/2==even->second two lines
      //3b i) Get m2,m3 of prev.two lines from buffer
      for (i=1;i>=0;i--) m[i+2]=GetMql(MqlBuffer,DimPic,level,TwoSets+i-1);
      //3b ii) Compute qG=Max(m1234)
      INT8 qG=-1;for (i=0;i<=3;i++) qG=Max(qG,m[i]);
      //3b iii) Encode m1234 using qG:
      if (qG>=qmin) for (i=3;i>=0;i--) EncodeLevelScale(m[i],Max(m[i],qmin),qG);
      //3b iv) Write qG to buffer on position of m2(left of the two positions)
      PutMql(MqlBuffer,DimPic,level,TwoSets-1,qG);
    } 
  }//for TwoSets

}


void RecodeLastLevels(INT16 *matrix,INT16 *LineBuffer,INT8 *qG,INT8 qmin,INT8 qmax){
  printf("Recoding last 2 levels\n");
  //1)Read matrix into line buffer
  //2)Encode qG[i], i=1,2,3 of prev levels 
  //3)Refine coefficients
  UINT16 DimPic=matrix[0];
  INT8 qminPrv=GetQminPrv(-1);//get the qminPrv value
  //1)Read 4x4 matrix of last two levels into input line buffer and compute max levels
  INT8 i;
  UINT16 m=0;
  for (i=0;i<=15;i++){//go through all coefficients of last 2 levels
    LineBuffer[i]=matrix[m+1];m++;if (m%4==0) m+=DimPic-4;
  }
  //2)Encode qG[i] of previous levels in the three subbands
  for (i=1;i<=3;i++) if (qG[i]<qminPrv) CodeLevel(qG[i],Max(qG[i],qmin),qminPrv-1);
  //3)Refine coefficients with/without sign:
  for (i=0;i<=15;i++) {
    if (Givelevel(LineBuffer,i)>=qminPrv) {//pix was encoded: code wo sign:
      INT8 exp;
      for (exp=qmin;exp<=qminPrv-1;exp++) { 
	UINT16 mask=1<<exp;//UINT16 mask=pow(2,exp);
	UINT16 bit=abs(LineBuffer[i]) & mask;//extract the bit
	WriteBit(bit>0);
      } 
    }else{//pixel was not yet encoded:code pixel w sign
      EncodePixelScale(LineBuffer[i],qmin,qminPrv-1);
    }
  }
}


UINT8 GetQminPrv(INT8 SetQminPrv){
  //returns qminPrv if SetQminPrv==-1
  static INT8 qminPrv;
  if (SetQminPrv>=0) qminPrv=SetQminPrv;//init
  return qminPrv;
}

void EncodePixelScale(INT16 pixel,INT8 qmin,INT8 qmax){
  //is qmax>=qminPrv
  //  yes: pixel was encoded
  //     if GiveLevel(pixel)<qminPrv
  //        yes: pixel was zero, encode with sign using qminPrv-1
  //         no: refine the pixel (wo sign)       using qminPrv-1
  //  no: pixel was not yet encoded: code w sign using qmax
  //printf("EncPixSc:%i ",pixel);
  INT8 qminPrv=GetQminPrv(-1);
  if (qmax>=qminPrv) {//1)set of coefficients was already encoded
    if (GiveLevel(pixel)<qminPrv) {//1a)pix was not coded(has been zero):code w sign
      CodePixelFlash(pixel,qmin,qminPrv-1);}
    else {//1b)pix was already coded:refine pixel wo sign using qmin and qminPrv-1
      INT8 exp;
      for (exp=qmin;exp<=qminPrv-1;exp++) { 
	UINT16 mask=1<<exp;//UINT16 mask=pow(2,exp);
	UINT16 bit=abs(pixel) & mask;//extract the bit
	WriteBit(bit>0);
      } 
    }//refined pixel wo sign
  }
  else {//2)qmax<qminPrv:set of coeff was not yet encoded 
    CodePixelFlash(pixel,qmin,qmax);}
}


void EncodeLevelScale(INT8 level,INT8 LowerBound,INT8 UpperBound) {
  // Is UpperBound>=qminPrv:Has the level already been encoded?
  //  yes: is level!=0 ?: has it been zero ?
  //       no: do nothing
  //       yes:encode to progressive stream with up.bound=qminPrv-1
  //  no:  encode with given UpperBound
  //printf("EncLvSc:%i ",level);
  INT8 qminPrv=GetQminPrv(-1);
  if (UpperBound>=qminPrv) {//level has already been encoded
    if(level>=qminPrv) return;//do nothing
    else UpperBound=qminPrv-1;//level has to be coded
  }
  //else write to progressive stream:
  CodeLevel(level,LowerBound,UpperBound);
}

