//TestFixed.c
//Rein Mai 2008

//#include "../SpisaTerm.h"
#include "TestFixed.h"
#include "FixedPoint.h"

/*
void testfix(){
  Matrix *Mvec=GiveFirst();// input matrix is in INT16 format
  UINT16 N=GiveCols(Mvec);
  StackDataPointer vec;
  vec.INT8p=&(Mvec->vector[4]);
  INT16 j;
  INT16 dest_line[N];
  INT8 expIn=0;
  INT8 expOut=7;
  for(j=0;j<N/2;j++){
    dest_line[j]=    FiltFixL(&vec.INT16p[0],j*2,N,expIn,expOut);
    dest_line[j+N/2]=FiltFixH(&vec.INT16p[0],j*2+1,N,expIn,expOut);
  } 
  for (j=0;j<N;j++) vec.INT16p[j]=dest_line[j];
}
void invtestfix(){
  Matrix *Mvec=GiveFirst();// input matrix is in INT16 format
  UINT16 N=GiveCols(Mvec);
  StackDataPointer vec;        
  vec.INT8p=&(Mvec->vector[4]);
  UINT16 j;
  INT16 dest_line[N];
  INT8 expIn=7;
  INT8 expOut=7;
  for (j=0;j<N;j++){
    dest_line[j] =FiltSynFixL(&vec.INT16p[0],j,N,expIn,expOut);
    dest_line[j]+=FiltSynFixH(&vec.INT16p[N/2],j,N,expIn,expOut);
  }
  for (j=0;j<N;j++) vec.INT16p[j]=dest_line[j];
  
}
*/
INT16 FiltFixL(INT16 *line_pic,UINT16 index,UINT16 N,INT8 expIn,INT8 expOut){
  INT16 c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-4;i<=4;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    c+=MulFixExp(line_pic[pixel_ind],AlFix(i),expIn,15,expOut);
  }
  return c;
}
INT16 FiltFixH(INT16 *line_pic,UINT16 index,UINT16 N,INT8 expIn,INT8 expOut){
  INT16 c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-3;i<=3;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    c+=MulFixExp(line_pic[pixel_ind],AhFix(i),expIn,15,expOut);
  } 
  return c;
}
INT16 FiltSynFixL(INT16 *line_pic,UINT16 index,UINT16 N,INT8 expIn,INT8 expOut){
  INT16 c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-3;i<=3;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    if (!(pixel_ind%2)) 
      c+=MulFixExp(line_pic[pixel_ind/2], AhFix(i),expIn,15,expOut)\
         *(abs(i)%2 *-2+1);
  }
  return c;
}

INT16 FiltSynFixH(INT16 *line_pic,UINT16 index,UINT16 N,INT8 expIn,INT8 expOut){
  INT16 c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-4;i<=4;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    if (pixel_ind%2) 
      c+=MulFixExp(line_pic[(pixel_ind-1)/2],AlFix(i),expIn,15,expOut)\
         *(abs(i)%2 *-2+1);
  }
  return c;
}
INT16 AlFix(INT8 index){
  switch(abs(index)){ 
  case 4:return  1240;//coefficients in Q0.15 format
  case 3:return -781;
  case 2:return -3625;
  case 1:return  12367;
  case 0:return  27941; 
  }
}
INT16 AhFix(INT8 index){
  switch(abs(index)){ 
  case 3:return  2115;
  case 2:return -1333;
  case 1:return -13700;
  case 0:return  25837;
 default:return  0;
  }
}
