//TransformPic.c
#include <stdio.h> //for printf
#include "TransformPic.h"
#include "HelpFct.h"
#include "lifting.h"

void FixWtFlash(INT16 *matrix,INT16 *dest,UINT8 Level,INT8 DoLifting,INT8 ExpOut){
  UINT16 N=GiveDim(matrix);
  printf("fct FixWtFlash called,N=%i\n",N);
  UINT8 level;          
  INT8 ExpIn=0;
  //ExpOut is the exponent of the wavelet coefficients of the first level
  //INT8 ExpOut=5;

  INT16 *HelpSwap;//to swap src and dst matrix
  for (level=1;level<=Level;level++){
    //printf("lev:%i N=%i \n",level,N);
    if (level!=1) {HelpSwap=matrix;matrix=dest;dest=HelpSwap;}
    OneLevFixWtFlash(matrix,dest,level,ExpIn,ExpOut,DoLifting);
    N/=2;ExpIn=ExpOut;ExpOut--;
  }
  if (Level%2==0) {printf("last swap\n");
                   HelpSwap=matrix;matrix=dest;dest=HelpSwap;}
  MergePics(matrix,dest,Level);
  rescale(dest,Level,ExpOut+1,0);//undo=0
}

void OneLevFixWtFlash(INT16 *PicSrc,INT16 *PicDst,\
                      UINT8 Level,INT8 expIn,INT8 expOut,
		      INT8 DoLifting){
  UINT16 N=GiveDim(PicSrc)/Pow(2,Level-1);
  //N: dimension of the input picture to be transformed
  printf("Level:%i N=%i\n",Level,N);
  INT16 LL_HL [N];         //destination 
  INT16 LH_HH [N];         //rows

  void *line_pic;          //current pic line read from SD card            
                           //can either be UINT8 (Level==1) or INT16 
  if (Level==1)  line_pic=(INT8 *) malloc(N*sizeof(INT8));
  else           line_pic=(INT16*) malloc(N*sizeof(INT16));
  INT8 j;
  UINT16 k;//vars for the three loops
  INT16 i; 
  UINT16 b;//help variable
 
  for (i=N/2-1;i>=0;i--){
  //for (i=0;i<=0;i++){
    for (b=0;b<N;b++){LL_HL[b]=0;LH_HH[b]=0;}//init buffers
    for (j=-4;j<=4;j++){
    //for(j=0;j<=0;j++){

      INT16 line_index=i*2+j;  
      if (line_index<0) line_index*=-1;                    //symmetric
      else if (line_index>N-1) line_index=2*N-2-line_index;//extension
      if (N==2) {if (abs(line_index)%2==0) line_index=0;   //
	         else line_index=1;}                       //

      ReadLine(PicSrc,line_index,line_pic,N,Level);
     
      if (Level==1) DoLifting=0;
      if (DoLifting) LiftLine(line_pic,N/2,expIn,expOut);

      INT16 L,H;
      INT16 *line=(INT16*) line_pic;
      for (k=0;k<N/2;k++){ 
        if (DoLifting) L=line[2*k];
	else L=filtfixL(line_pic,k*2,N,Level,expIn,expOut);
	LL_HL[k]+=MulFixExp(L,alfix(j),expOut,15,expOut);//update LL
        LH_HH[k]+=MulFixExp(L,ahfix(j-1),expOut,15,expOut);//update LH
	
	if (DoLifting) H=line[2*k+1];
	else  H=filtfixH(line_pic,k*2+1,N,Level,expIn,expOut);
	LL_HL[k+N/2]+=MulFixExp(H,alfix(j),  expOut,15,expOut);//update HL
        LH_HH[k+N/2]+=MulFixExp(H,ahfix(j-1),expOut,15,expOut);//update HH
      } 
    }
    WriteLine(PicDst,i,LL_HL,N);
    WriteLine(PicDst,i+N/2,LH_HH,N);
  }
  free(line_pic);
}

INT16 filtfixL(INT16 *line_pic,UINT16 index,UINT16 N,\
               UINT8 Level,INT8 expIn,INT8 expOut){
  INT8 *line_pic8=(INT8*) line_pic;
  INT16 c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-4;i<=4;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    
    if (Level==1)
      c+=MulFixExp(line_pic8[pixel_ind],alfix(i),expIn,15,expOut);
    else
      c+=MulFixExp(line_pic[pixel_ind],alfix(i),expIn,15,expOut);
  }
  return c;
}
INT16 filtfixH(INT16* line_pic,UINT16 index,UINT16 N,\
               UINT8 Level,INT8 expIn,INT8 expOut){
  INT8 *line_pic8=(INT8*) line_pic;
  INT16 c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-3;i<=3;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    if (Level==1)
      c+=MulFixExp(line_pic8[pixel_ind],ahfix(i),expIn,15,expOut);
    else
      c+=MulFixExp(line_pic[pixel_ind],ahfix(i),expIn,15,expOut);
  }
  return c;
}

INT16 alfix(INT8 index){
 switch(abs(index)){ 
  case 4:return  1240;//coefficients in Q0.15 format
  case 3:return -781;
  case 2:return -3625;
  case 1:return  12367;
  case 0:return  27941; 
 default:return 0;// not used (prevent warning)
  }
}
INT16 ahfix(INT8 index){
 switch(abs(index)){ 
  case 3:return  2115;
  case 2:return -1333;
  case 1:return -13700;
  case 0:return  25837;
 default:return  0;
  }
}

INT16 GiveDim(INT16* pic) {return pic[0];}
void ReadLine8 (INT16* pic,UINT16 lineindex,INT8 *LineBuffer,UINT16 LineWidth){
  UINT16 DimPic=GiveDim(pic);
  UINT16 i;
  for (i=0;i<LineWidth;i++) LineBuffer[i]=pic[lineindex*DimPic+i+1];
}

void ReadLine(INT16* pic,UINT16 lineindex,INT16 *LineBuffer,UINT16 LineWidth,UINT8 Level){
  INT8* LineBuffer8=(INT8*)LineBuffer;  
  UINT16 DimPic=GiveDim(pic);
  UINT16 i;
  if (Level==1)
    for (i=0;i<LineWidth;i++) LineBuffer8[i]=pic[lineindex*DimPic+i+1];
  else
    for (i=0;i<LineWidth;i++) LineBuffer[i]=pic[lineindex*DimPic+i+1];
}

void WriteLine(INT16* pic,UINT16 lineindex,INT16 *LineBuffer,UINT16 LineWidth){
  UINT16 DimPic=GiveDim(pic);
  UINT16 i;
  for (i=0;i<LineWidth;i++) pic[lineindex*DimPic+i+1]=LineBuffer[i];
}

void MergePics(INT16 *src, INT16 *dst,UINT8 MaxLev){
  INT16 DimPic=GiveDim(src);
  //UINT8 MaxLev=Log2(GiveDim(src));
  printf("MergePics called. MaxLev=%i\n",MaxLev);
  UINT8 lev;
  for (lev=2;lev<=MaxLev;lev+=2){
    UINT16 N=GiveDim(src)/Pow(2,lev-1);
    UINT16 i,b,start;
    for (i=0;i<N;i++) {//rows
      if ((i<N/2)&&(lev<MaxLev)) start=N/2;else start=0;
      for (b=start;b<N;b++) {dst[i*DimPic+b+1]=src[i*DimPic+b+1];
	//printf("%i:",i*DimPic+b+1);
      }
    }
    //printf("next\n");
  }

}




void PrintLine(INT16* linepic,UINT16 N,UINT8 Level){
  //print the line

  INT8* linepic8=(INT8*)linepic;  
  int x;
  if (Level==1)
    for (x=0;x<N;x++) printf("%i ",linepic8[x]);
  else
    for (x=0;x<N;x++) printf("%i ",linepic[x]);
  printf("\n");
}

/*
void rescale(INT16 *pic,UINT8 LastWaveletLevel,UINT8 ExpLastLevel,\
	     UINT8 undo){
  //the matrix to be rescaled is in the integer 16 bit signed data format
  //see the coder.h for more details
  printf("fct rescale() called.\n>>");
  UINT16 Npic=GiveDim(pic);
  UINT8 lev;
  UINT16 N,rw,cl,ColStart;
  for (lev=LastWaveletLevel;lev>=1;lev--)
    {
      N=Npic/Pow(2,lev-1);
      // bug feb 09: if (ExpLastLevel!=0)
      if (ExpLastLevel!=0) for (rw=0;rw<N;rw++){ 
	if ((rw<N/2)&&(lev!=LastWaveletLevel)) ColStart=N/2;else ColStart=0;
	for(cl=ColStart;cl<N;cl++)
          if (undo==1) pic[1+rw*Npic+cl]<<=ExpLastLevel;
	  else { //extract the LSB bit for rounding operation:
            pic[1+rw*Npic+cl]>>=ExpLastLevel-1;
	    INT16 mask=1;UINT8 bit=pic[1+rw*Npic+cl]&mask;
	    pic[1+rw*Npic+cl]>>=1;
	    //perform rounding by adding the previous LSB Bit:
	    pic[1+rw*Npic+cl]+=bit;
          }
	
      }
      ExpLastLevel++;
    }
}
*/
