//FpInvTransformPic.c
//Rein Mai 2008
#include "../SpisaTerm.h"
#include "FpTransformPic.h"
#include "FpInvTransformPic.h"

void FloatInvWaveletTransform(){
  Matrix *Mpic=GiveFirst();
  UINT16 Npic=GiveCols(Mpic);
  UINT16 N=2;
  while(N<=Npic){
    transpose(Mpic,N);
    dwrec(Mpic,N);
    transpose(Mpic,N);
    dwrec(Mpic,N);
    N*=2;
  }
}

void dwrec(Matrix* Mpic,UINT16 N){
  UINT16 Npic=GiveCols(Mpic);
  printf("N:%i",N);
  StackDataPointer pic;        
  pic.INT8p=&(Mpic->vector[4]);
  UINT16 i,j;
  float dest_line[N];
  for (i=0;i<N;i++){//do for each line
    for (j=0;j<N;j++){
      dest_line[j] =FiltSynFloatL(&pic.FLOATp[i*Npic],j,N);
      dest_line[j]+=FiltSynFloatH(&pic.FLOATp[i*Npic+N/2],j,N);
    }
    for (j=0;j<N;j++) pic.FLOATp[i*Npic+j]=dest_line[j];
  }
}


float FiltSynFloatL(float *line_pic,UINT16 index,UINT16 N){
 float c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-3;i<=3;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    if (!(pixel_ind%2)) c+=line_pic[pixel_ind/2]*Ah(i)*(abs(i)%2 *-2+1);
  }
  return c;
}

float FiltSynFloatH(float *line_pic,UINT16 index,UINT16 N){
 float c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-4;i<=4;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    if (pixel_ind%2) c+=line_pic[(pixel_ind-1)/2]*Al(i)*(abs(i)%2 *-2+1);
  }
  return c;
}
