//TransformPic.c
//Rein Mai 2008

#include "../SpisaTerm.h"
#include "FpTransformPic.h"
//#include "TransformPic.h"

void FloatWaveletTransform(){
  Matrix *Mpic=GiveFirst();//floating point pic is in stack 
  UINT16 Npic=GiveCols(Mpic);
  UINT16 N=Npic;    
  while (N!=1) {
    dwt(Mpic,N);
    transpose(Mpic,N);
    dwt(Mpic,N);
    transpose(Mpic,N);
    N/=2;
  }
}
void dwt(Matrix* Mpic,UINT16 N){
  UINT16 Npic=GiveCols(Mpic);
  printf("N:%i",N);
  StackDataPointer pic;        
  pic.INT8p=&(Mpic->vector[4]);
  UINT16 i,j;
  float dest_line[N];
  for (i=0;i<N;i++){//do for each line 
    for (j=0;j<N/2;j++) {
      dest_line[j]=    FiltFloatL(&pic.FLOATp[i*Npic],j*2,N);
      dest_line[j+N/2]=FiltFloatH(&pic.FLOATp[i*Npic],j*2+1,N);
    } 
    for (j=0;j<N;j++) pic.FLOATp[i*Npic+j]=dest_line[j];
  }
}
void transpose(Matrix* Mpic,UINT16 N){
  UINT16 Npic=GiveCols(Mpic);
  printf("transpose N:%i\n",N); 
  StackDataPointer pic;        
  pic.INT8p=&(Mpic->vector[4]);
  float Mhelp[N*N];
  UINT32 rw,cl,i;
  for(rw=0;rw<N;rw++)for(cl=0;cl<N;cl++)
    Mhelp[cl*N+rw]=pic.FLOATp[rw*Npic+cl];
  for(rw=0;rw<N;rw++)for(cl=0;cl<N;cl++)
    pic.FLOATp[rw*Npic+cl]=Mhelp[rw*N+cl];
}
float FiltFloatL(float *line_pic,UINT16 index,UINT16 N){
  float c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-4;i<=4;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    c+=line_pic[pixel_ind]*Al(i);
  }
  return c;
}
float FiltFloatH(float *line_pic,UINT16 index,UINT16 N){
  float c=0;
  INT8 i;
  INT16 pixel_ind;
  for (i=-3;i<=3;i++){
    pixel_ind=index+i;
    if (N==2) pixel_ind=abs(pixel_ind)%2;             //symmetric
    if (pixel_ind<0) pixel_ind=-pixel_ind;            //
    if (pixel_ind>N-1) pixel_ind=abs(2*N-2-pixel_ind);//extension
    c+=line_pic[pixel_ind]*Ah(i);
  }
  return c;
}
float Al(INT8 index){
  switch(abs(index)){ 
  case 4:return  0.0378284555072640;
  case 3:return -0.0238494650195568;
  case 2:return -0.1106244044184372;
  case 1:return  0.3774028556128307;
  case 0:return  0.8526986790088938; 
  }
}
float Ah(INT8 index){
  switch(abs(index)){ 
  case 3:return  0.0645388826287616;
  case 2:return -0.0406894176092048;
  case 1:return -0.4180922732220353;
  case 0:return  0.7884856164063714;
 default:return  0.;
  }
}
